Loading...
Searching...
No Matches
MinCostArborescence< GR, CM, TR >::SetPredMap< T > Struct Template Reference

## Detailed Description

template<typename GR, typename CM, typename TR>
template<class T>
struct lemon::MinCostArborescence< GR, CM, TR >::SetPredMap< T >

Named parameter for setting `PredMap` type. It must meet the WriteMap concept, and its value type must be the `Arc` type of the digraph.

`#include <lemon/min_cost_arborescence.h>`

Inheritance diagram for MinCostArborescence< GR, CM, TR >::SetPredMap< T >:
[legend]

## Additional Inherited Members

Public Types inherited from MinCostArborescence< Digraph, CostMap, SetPredMapTraits< T > >
typedef SetPredMapTraits< T > | Traits
| The traits class of the algorithm.
typedef Traits::Digraph | Digraph
| The type of the underlying digraph.
typedef Traits::CostMap | CostMap
| The type of the map that stores the arc costs.
typedef Traits::Value | Value
| The type of the costs of the arcs.
typedef Traits::PredMap | PredMap
| The type of the predecessor map.
typedef Traits::ArborescenceMap | ArborescenceMap
| The type of the map that stores which arcs are in the arborescence.
Public Member Functions inherited from MinCostArborescence< Digraph, CostMap, SetPredMapTraits< T > >
| ~MinCostArborescence ()
| Destructor.
MinCostArborescence & | arborescenceMap (ArborescenceMap &m)
| Sets the arborescence map.
MinCostArborescence & | predMap (PredMap &m)
| Sets the predecessor map.
void | init ()
| Initializes the internal data structures.
void | addSource (Node source)
| Adds a new source node.
Node | processNextNode ()
| Processes the next node in the priority queue.
int | queueSize () const
| Returns the number of the nodes to be processed.
bool | emptyQueue () const
| Returns `false` if there are nodes to be processed.
void | start ()
| Executes the algorithm.
void | run (Node s)
| Runs MinCostArborescence algorithm from node `s`.
Value | arborescenceCost () const
| Returns the cost of the arborescence.
bool | arborescence (Arc arc) const
| Returns `true` if the arc is in the arborescence.
Arc | pred (Node node) const
| Returns the predecessor arc of the given node.
bool | reached (Node node) const
| Indicates that a node is reachable from the sources.
bool | processed (Node node) const
| Indicates that a node is processed.
int | dualNum () const
| Returns the number of the dual variables in basis.
Value | dualValue () const
| Returns the value of the dual solution.
int | dualSize (int k) const
| Returns the number of the nodes in the dual variable.